Description

SystemMetadata changes frequently by both d1_synchronization and d1_replication once an object's metadata documents are

synchronized.  Since MNs can only set access policies through the CN, the CN needs to synchronize the system metadata back to

each MN replica node so they can 1) have the latest version (serialVersion) and 2) enforce the correct access policies.

Update ACL only via CN, only possible if Auth MN is Tier2+):

0. User edits ACL on an object using ITK tool;

1. Update ACL on CN-1;

a. lock PID

b. check serial number on sysmeta - change request serial # must match sys meta serial

c. put systemMetadata on CN-1 via hazelcast

e. changes propogated to other CNs via hazelcast

d. unlock PID

2. CN-1 pushes ACL to all object copies;

3. CN-1 verifies ACL change;

If a Tier 1 MN is authoritative, then there is no support for changing ACLs.

If a Tier 1 MN attempts to create an object that has an ACL other than public read, that synchronize to the CN should fail.  This is

similar to the problem that the synchronize should fail if the identifier for the object is not unique.  

Subtasks:

Task # 1969: Add MNStorage.updateSystemMetadata() method to documentation Closed

Task # 1970: Remove 	MNAuthorization.setAccessPolicy() from documentation Closed

Task # 1971: Remove 	MNAuthorization.setAccessPolicy() from Metacat Closed

Task # 1972: Remove 	MNAuthorization.setAccessPolicy() from GMN Closed

Task # 1973: Remove 	MNAuthorization.setAccessPolicy() from Dryad Rejected

Task # 1974: Call MNStorage.updateSystemMetadata() on previous replicas when new  repli... Rejected

Task # 1975: Add MNStorage.updateSystemMetadata() to Metacat Rejected

Task # 1976: Add MNStorage.updateSystemMetadata() to GMN Closed

Task # 1977: Add MNStorage.updateSystemMetadata() method to MNStorage Interface Rejected

Related issues:

Related to Infrastructure - Story #1827: Design AccessPolicy update restrictions Closed 2011-10-07

Related to Infrastructure - Story #1952: SerialVersion in SystemMetadata need... Closed 2011-11-01

History

#1 - 2011-11-07 18:41 - Dave Vieglais

- Target version changed from Sprint-2011.44-Block.6 to Sprint-2011.45-Block.6

- Position set to 2

#2 - 2011-11-15 03:34 - Dave Vieglais

- Target version changed from Sprint-2011.45-Block.6 to Sprint-2011.46-Block.6

- Position deleted (5)

- Position set to 1
#3 - 2011-11-15 17:58 - Robert Waltz

- Status changed from New to Closed
